
!GRPharoPlatform methodsFor: '*seaside-pharo-rest-core' stamp: 'pmm 8/8/2010 09:55'!
argumentNamesOf: aMethod
	^ aMethod methodNode arguments collect: [ :each |
		each key ]! !

!GRPharoPlatform methodsFor: '*seaside-pharo-rest-core' stamp: 'pmm 10/17/2010 15:50'!
methodsWithHttpPragmaIn: aClass do: aFourArgumentBlock
	aClass selectorsDo: [ :selector |
		| httpMethodName method |
		httpMethodName := nil.
		method := aClass >> selector.
		method pragmas do: [ :pragma |
			(WARoute httpMethodNames includes: pragma keyword) ifTrue: [
				httpMethodName := pragma keyword greaseString ] ].
		httpMethodName isNil ifFalse: [
			| path consumes produces |
			path := method pragmaAt: #Path:.
			consumes := self mimeTypeMatchesAt: #Consumes: in: method.
			produces := self mimeTypeMatchesAt: #Produces: in: method..
			aFourArgumentBlock valueWithArguments: (Array
				with: method
				with: selector
				with: httpMethodName
				with: (path isNil ifFalse: [ path argumentAt: 1 ] )
				with: produces
				with: consumes) ] ]! !

!GRPharoPlatform methodsFor: '*seaside-pharo-rest-core' stamp: 'pmm 10/17/2010 14:19'!
mimeTypeMatchesAt: aSymbol in: aMethod
	| matches |
	matches := aMethod pragmas
		select: [ :each | each key = aSymbol ]
		thenCollect: [ :each | WAMimeTypeMatch fromString: each arguments first ].
	^ matches isEmpty
		ifTrue: [ WAWildcardMimeTypeMatch new ]
		ifFalse: [ WACompositeMimeTypeMatch matches: matches  ]! !

!GRPackage class methodsFor: '*seaside-pharo-rest-core' stamp: 'pmm 8/8/2010 11:22'!
seasidePharoRestCore
	^ self new
		name: 'Seaside-Pharo-REST-Core';
		description: 'Write RESTful web services using Seaside';
		addDependency: 'Seaside-REST-Core';
		url: #seasideAddonsUrl;
		yourself! !
